#!/usr/bin/env python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008-2008 by Steve Walter	                           *
#*                                                                         *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 3 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

## @package BladeDesigner3D
# @author Steve Walter
# @date 19.05.2009

from PyQt4.QtGui import QDialog, QApplication
from Ui_AboutDialog import Ui_AboutDialog as AboutDialog
from turboMachine import BladeDesignerVersion

class QAboutDialog(QDialog, AboutDialog):

	## @brief Constructor of QAboutDialog<br><em>Konstruktor von QAboutDialog</em>
	#
	# This function only sets the data to show
	# <br><em>Diese Funktion setzt lediglich die anzuzeigenden Daten
	# </em>
	#
	def __init__(self, pParent = None):
		#Dialog initialisiseren
		QDialog.__init__(self, pParent)
		#Ui aufsetzen
		self.setupUi(self)
		#Versiontext ändern
		strNewText = self.LTitle.text().replace("#VersionsNummer", BladeDesignerVersion)
		#Neuen Text einstellen
		self.LTitle.setText(strNewText)

## @brief Main Programm
#Testfall nur bei entsprechenden Parameter ausführen
#TODO: Eventuell entfernen
#if (len(sys.argv) > 1) and (sys.argv[1] == 'ShowTestCase'):
	##Qt-Application erstellen
	#pApp = QApplication([])
	##Dummy Dialog zur Anzeige des Widgets erstellen
	#pDlg = QStatusDialog()
	##Dialog anzeigen
	#pDlg.show()
	##Applikation ausführen
	#sys.exit(pApp.exec_())

if(__name__ == "__main__"):
	#Qt-Application erstellen
	pApp = QApplication([])
	#Dummy Dialog zur Anzeige des Widgets erstellen
	pDlg = QAboutDialog()
	#Dialog anzeigen
	pDlg.show()
	#Applikation ausführen
	pApp.exec_()
	