#!/usr/bin/env python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008-2008 by Sebastian Barthmes                         *
#*                                                                         *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 3 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

#Python Imports

import sys,os
sys.path.insert(0 ,"../../src") #
import turboMachine
from numpy import *
from copy import *

#Turbomachine Initialisation
workdir=os.path.abspath('rot')   # '/path/to/workdir'

turbo=turboMachine.turboMachine(workdir)
turbo.debug=1

## Rowdefinition

turbo.listRows[0].useNurbsXml=True

#mesh
turbo.listRows[0].noLayer=6
#turbo.listRows[0].startProfile=2

## Berechne die Turbomaschine
turbo.computeTurboMachine()

turbo.listRows[0].initMesh()

###############################
## BlockMeshDictGen Initialisierung
###############################

#------------------- basic infortmation ----------------------------------------------------------#

turbo.listRows[0].mesh.debug = 1
turbo.listRows[0].mesh.plot = False
turbo.listRows[0].mesh.layerToPlot = 0
turbo.listRows[0].mesh.coordsToPolt  = [3,0]

turbo.listRows[0].mesh.gridType = 'rS'
turbo.listRows[0].mesh.dimension = '3D'
turbo.listRows[0].mesh.convertToMeters = 0.001



# what kind of row
turbo.listRows[0].mesh.zoneName = "rotor"

## what kind of computation
#turbo.listRows[0].mesh.cyclicGgi = False
##turbo.listRows[0].mesh.surfaceOfRevolution = True
#turbo.listRows[0].mesh.dimensionMode = 1
#turbo.listRows[0].mesh.convertToMeters = 0.001
##turbo.listRows[0].mesh.convertToMeters = 1.0
turbo.listRows[0].topology = "O10H"

# opposite edges have same grading
turbo.listRows[0].mesh.simpleGrading = True

#------------------- number of Cells -------------------------------------------------------------#
## noCellsCirc = [axRow0, axRow1, axRow2, axRow3]
turbo.listRows[0].mesh.noCellsAx = [20, 20, 20, 20]

## noCellsCirc = [circRow0, circRow1, circRow2]
turbo.listRows[0].mesh.noCellsCirc = [10, 12, 10]

## o grid
turbo.listRows[0].mesh.noCellsOGrid = 7

for layerIndex in xrange(turbo.listRows[0].noLayer):
	
	#------------------- o grid information --------------------------------------------------#
	turbo.listRows[0].mesh.oGridWidth[layerIndex] = 1.5
	
	#------------------- garding information -------------------------------------------------#
	## look number of celles
	turbo.listRows[0].mesh.simpleAxGrading[layerIndex] = [1, 1, 1, 1]
	turbo.listRows[0].mesh.simpleCircGrading[layerIndex] = [0.2, 1, 5]
	turbo.listRows[0].mesh.simpleOGridGrading[layerIndex] = 1
	
	#------------------- control parameter (cP) ----------------------------------------------#
	
	turbo.listRows[0].mesh.inletOffset[layerIndex]  = [0.4, 0.15]
	turbo.listRows[0].mesh.outletOffset[layerIndex] = [0, 0.90]
	
	turbo.listRows[0].mesh.uValueOnProfile[layerIndex]         = [0.008, 0.495, 0.510, 0.993]
	turbo.listRows[0].mesh.uValueOnScaledProfile[layerIndex]   = [0.006, 0.48, 0.518, 0.981]
	
	## relControlPoint = [relP, relZ] 
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 0] = [ 0.50, 0.26]
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 1] = [ 0.60, 0.05]
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 2] = [ 0.15, 0.05]
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 3] = [-0.50, 0.23]
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 4] = [-0.50, 0.90]
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 5] = [-0.21, 0.94]
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 6] = [ 0.21, 0.94]
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 7] = [ 0.50, 0.90]

# Netz berechnen
turbo.listRows[0].computeMesh()

