#!/usr/bin/env python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008-2008 by Sebastian Barthmes                         *
#*                                                                         *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 3 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

#Python Imports

import sys,os
sys.path.insert(0 ,"../../src") #
import turboMachine
from numpy import *
from copy import *

#Turbomachine Initialisation
workdir=os.path.abspath('cascade')   # '/path/to/workdir'

turbo=turboMachine.turboMachine(workdir)
turbo.debug=1

## Rowdefinition
turbo.listRows[0].useNurbsXml=True

#mesh
turbo.listRows[0].topology = "O10H"
turbo.listRows[0].noLayer=3
#turbo.listRows[0].startProfile=3

## Berechne die Turbomaschine
turbo.computeTurboMachine()

turbo.listRows[0].initMesh()

###############################
## BlockMeshDictGen Initialisierung
###############################

#------------------- basic infortmation ----------------------------------------------------------#

turbo.listRows[0].mesh.debug = 1
turbo.listRows[0].mesh.plot = False
turbo.listRows[0].mesh.layerToPlot = 0
turbo.listRows[0].mesh.coordsToPolt  = [3, 0]

# what kind of row
turbo.listRows[0].mesh.zoneName = "rotor"

# what kind of computation


turbo.listRows[0].mesh.girdType = 'fS'
turbo.listRows[0].mesh.dimension = '3D'
turbo.listRows[0].mesh.convertToMeters = 0.001
#turbo.listRows[0].mesh.symCascade = True


# opposite edges have same grading
turbo.listRows[0].mesh.simpleGrading = True

#------------------- number of Cells -------------------------------------------------------------#
## noCellsCirc = [axRow0, axRow1, axRow2, axRow3]
turbo.listRows[0].mesh.noCellsAx = [10, 20, 20, 20]

turbo.listRows[0].mesh.noCellsRad = [10, 10]

## noCellsCirc = [circRow0, circRow1, circRow2]
turbo.listRows[0].mesh.noCellsCirc = [10, 12, 10]

## o grid
turbo.listRows[0].mesh.noCellsOGrid = 7

for layerIndex in xrange(turbo.listRows[0].noLayer):
	
	#------------------- o grid information --------------------------------------------------#
	turbo.listRows[0].mesh.oGridWidth[layerIndex] = 1.5
	
	#------------------- garding information -------------------------------------------------#
	## look number of celles
	turbo.listRows[0].mesh.simpleAxGrading[layerIndex] = [1, 1, 1, 1]
	turbo.listRows[0].mesh.simpleCircGrading[layerIndex] = [1, 1, 1]
	turbo.listRows[0].mesh.simpleOGridGrading[layerIndex] = 1
	
	#------------------- control parameter (cP) ----------------------------------------------#
	
	## controlParameterInlet/~Outlet = [phi@inlet/outlet*cP, phi+deltaPhi*cP@inlet*/outlet, phi+-deltaPhi*cP@inlet*/outlet]
	turbo.listRows[0].mesh.inletOffset[layerIndex]  = [ 0, 0.19]
	turbo.listRows[0].mesh.outletOffset[layerIndex] = [ 0, 0.68]
	
	## uValueOnProfile/~ScaledProfile = [defBlock@trailingEdge, defBlock@leadingEdge, defBlock@leadingEdge, defBlock@trailingEdge]
	turbo.listRows[0].mesh.uValueOnProfile[layerIndex]         = [0.008, 0.495, 0.510, 0.993]
	turbo.listRows[0].mesh.uValueOnScaledProfile[layerIndex]   = [0.006, 0.48, 0.518, 0.981]
	
	## uValueOnRevolutionCurve = [defZValue@inlet, defZValue@leadingEdge1axBlock, defZValue@trailingEdge2axBlock, defZValue@outlet]
	#turbo.listRows[0].mesh.uValueOnRevolutionCurve[layerIndex] = [0.000, 0.180, 0.700, 1.000]
	
	## relControlPoint = [relX, relY] 
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 0] = [ 0.50, 0.19]
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 1] = [ 0.30, 0.05]
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 2] = [-0.30, 0.05]
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 3] = [-0.50, 0.19]
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 4] = [-0.50, 0.69]
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 5] = [-0.30, 0.85]
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 6] = [ 0.30, 0.85]
	turbo.listRows[0].mesh.relControlPoint[layerIndex, 7] = [ 0.50, 0.69]

# Netz berechnen
turbo.listRows[0].computeMesh()

