#!/usr/bin/env python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008-2009 by Sebastian Barthmes                         *
#*                                                                         *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 3 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

import sys,os
sys.path.insert(0 ,"../../src") #set the path to bladedesigner-sources here
import turboMachine
from numpy import *

### This is the default initfile for new BladeDesigner3D projects. Add your Turbomachine here ;-)


#Turbomachine Initialisation
workdir='/path/to/workdir' # Set your working directory (will be created on runtime as needed). If an xml-savefile exists in this dir, it will be used for initialisation
configuration=[7,7,7] # Three bladerows with seven profiles each

turbo=turboMachine.turboMachine(workdir,configuration)
turbo.debug=1

## Row Definition
turbo.listRows[0].debug=1
# Add the bladerow parameters for all bladerows here

## Profiledefinition
turbo.listRows[0].listProfiles[0].debug=1
# Add the profile parameters for all profiles of all bladerows here

## Compute the whole turbomachine geometry
turbo.computeTurboMachine()

## If you want to compute a blockMeshDict define mesh parameters here
# turbo.listRows[0].mesh.oGridWidth = 1
# turbo.listRows[0].computeMesh()
