#!/usr/bin/env python
# -*- coding: utf-8 -*-

#***************************************************************************
#*   Copyright (C) 2008-2008 by Sebastian Barthmes                         *
#*   sebastian.barthmes@gmail.com                                          *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 3 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

## @package BladeDesigner3D
# @author Sebastian G. Barthmes
# @date 28.04.2009


# Python Imports
# üöä
import sys, os
sys.path.insert(0 ,"../../src")

import turboMachine
from numpy import *
from copy import *

#Turbomachine Initialisation
workdir=os.path.abspath('radial_pump')   # '/path/to/workdir'
configuration=[3]

useNurbsXml=0

turbo=turboMachine.turboMachine(workdir,configuration)
turbo.debug=1


# Nächste Zeile auskommentieren!
#'''

z1=0.
z2=60.
r1=50
r2=200

#################################################    ROTOR     #############################################


## Rowdefinition
if useNurbsXml==1:
	turbo.listRows[0].useNurbsXml=True

turbo.listRows[0].definition = 0
turbo.listRows[0].numberBlades = 13
turbo.listRows[0].omega = 850

turbo.listRows[0].coordinatesHub = zeros((5,2))
turbo.listRows[0].coordinatesShroud = zeros((5,2))
turbo.listRows[0].coordinatesHub[:,0]=z2
turbo.listRows[0].coordinatesHub[:,1]=linspace(r1,r2,5)
turbo.listRows[0].coordinatesShroud[:,0]=z1
turbo.listRows[0].coordinatesShroud[:,1]=linspace(r1,r2,5)

turbo.listRows[0].coordinatesStackingLine = zeros((5,2))
turbo.listRows[0].coordinatesStackingLine[:,0]=linspace(z2,z1,5)
turbo.listRows[0].coordinatesStackingLine[:,1]=(r2-r1)/2+r1

turbo.listRows[0].span=[0.0,0.5,1.0]

turbo.listRows[0].debug=1
turbo.listRows[0].angleFlag=1
turbo.listRows[0].teflag="round"


#import pylab as p
#r=turbo.listRows[0]
#p.plot(r.coordinatesShroud[:,0],r.coordinatesShroud[:,1],'bo')
#p.plot(r.coordinatesHub[:,0],r.coordinatesHub[:,1],'bo')
#p.axis('equal')
#p.show()


# Skelettlinien Kontrollpunkte
cpcamber=zeros((6,2))
cpcamber[:,0]=[0,0.1,0.3,0.6,0.7,1.0]
#cpcamber[:,1]=[0,0.03,0.04,0.04,0.04,0.0]

# Dickenverteilung Kontrollpunkte
cpth=zeros((6,2))
cpth[:,0]=[0,0.1,0.3,0.6,0.7,1.0]
cpth[:,1]=[0,0.025,0.025,0.025,0.025,0.0]

s=turbo.listRows[0]
##Profildefinition:
for p in s.listProfiles:
	p.flagCamberLine=2
	p.flagThickDistr=2
	p.controlPointsCamb=cpcamber
	p.controlPointsThick=cpth
	p.profileResolution=200
	p.weightCondition=0
	p.weightCombination=2
	p.polyThickRBs=ones((9))
	p.debug=0

s.setChordLengths([100,100,100])
s.setIOAngles([90,90,90],[90,90,90])
s.setStaggerAngles([45,45,45])



## Berechne die Turbomaschine
turbo.computeTurboMachine()

#turbo.writeTurboMachineXml(0)

blade=turbo.listRows[0]

############## Exporting ######################
#blade.exportBladeToIGES()
#blade.exportBladeToSTEP()
#blade.exportBladeToSTL()

#turbo.exportTurboMachineToIGES()
#turbo.exportTurboMachineToSTEP()

## Schreibe vrml-Dateien der Reihen
#for n in range(turbo.numberRows):
	#turbo.listRows[n].writeVRML()

############ opencascade test display ###############
#blade.displayNurbsCurves() #Only select one display per run!
turbo.displayViewer()
